
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ioctl用法详解 (网络) / iVAN</title>

    <meta name="description" content="ioctl用法详解 (网络) 本函数影响由fd参数引用的一个打开的文件. #include#include int ioctl( int fd, int request, .../* void *arg */ );返回0:成功    -1:出错 第三个参数总是一个指针,但指针的类型依赖于request参数.我们可以把和网络相关的请求划分为6类:套接口操作文件操作接口操作ARP高速缓存操作路由表操作流系统下表列出了网络相关ioctl请求的request参数以及arg地址必须指向的数据类型: (图1)   套接口操作:明确用于套">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ioctl用法详解 (网络)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本函数影响由fd参数引用的一个打开的文件。</p>
<p>#include<br />#include</p>
<p>int ioctl( int fd, int request, .../* void *arg */ );<br />返回0：成功    -1：出错</p>
<p>第三个参数总是一个指针，但指针的类型依赖于request参数。<br />我们可以把和网络相关的请求划分为6类：<br />套接口操作<br />文件操作<br />接口操作<br />ARP高速缓存操作<br />路由表操作<br />流系统<br />下表列出了网络相关ioctl请求的request参数以及arg地址必须指向的数据类型：</p>
<p>（图1）</p>
<p> </p>
<p>套接口操作：<br />明确用于套接口操作的ioctl请求有三个,它们都要求ioctl的第三个参数是指向某个整数的一个指针。</p>
<p>SIOCATMARK:    如果本套接口的的度指针当前位于带外标记，那就通过由第三个参数指向的整数返回一个非0值；否则返回一个0值。POSIX以函数sockatmark替换本请求。<br />SIOCGPGRP：       通过第三个参数指向的整数返回本套接口的进程ID或进程组ID，该ID指定针对本套接口的SIGIO或SIGURG信号的接收进程。本请求和fcntl的F_GETOWN命令等效，POSIX标准化的是fcntl函数。<br />SIOCSPGRP：     把本套接口的进程ID或者进程组ID设置成第三个参数指向的整数，该ID指定针对本套接口的SIGIO或SIGURG信号的接收进程，本请求和fcntl的F_SETOWN命令等效，POSIX标准化的是fcntl操作。</p>
<p>文件操作：<br />以下5个请求都要求ioctl的第三个参数指向一个整数。</p>
<p>FIONBIO：        根据ioctl的第三个参数指向一个0或非0值分别清除或设置本套接口的非阻塞标志。本请求和O_NONBLOCK文件状态标志等效，而该标志通过fcntl的F_SETFL命令清除或设置。</p>
<p>FIOASYNC：      根据iocl的第三个参数指向一个0值或非0值分别清除或设置针对本套接口的信号驱动异步I/O标志，它决定是否收取针对本套接口的异步I/O信号（SIGIO）。本请求和O_ASYNC文件状态标志等效，而该标志可以通过fcntl的F_SETFL命令清除或设置。</p>
<p>FIONREAD：     通过由ioctl的第三个参数指向的整数返回当前在本套接口接收缓冲区中的字节数。本特性同样适用于文件，管道和终端。</p>
<p>FIOSETOWN：    对于套接口和SIOCSPGRP等效。<br />FIOGETOWN：    对于套接口和SIOCGPGRP等效。</p>
<p>接口配置：<br />得到系统中所有接口由SIOCGIFCONF请求完成，该请求使用ifconf结构，ifconf又使用ifreq<br />结构，如下所示：</p>
<p>Struct ifconf{<br />    int ifc_len;                 // 缓冲区的大小<br />    union{<br />        caddr_t ifcu_buf;        // input from user-&gt;kernel<br />        struct ifreq *ifcu_req;    // return of structures returned<br />    }ifc_ifcu;<br />};</p>
<p>#define ifc_buf ifc_ifcu.ifcu_buf    //buffer address<br />#define ifc_req ifc_ifcu.ifcu_req    //array of structures returned</p>
<p>#define IFNAMSIZ 16</p>
<p>struct ifreq{<br />    char ifr_name[IFNAMSIZ];           // interface name, e.g., “le0”<br />    union{<br />        struct sockaddr ifru_addr;<br />        struct sockaddr ifru_dstaddr;<br />        struct sockaddr ifru_broadaddr;<br />        short ifru_flags;<br />        int ifru_metric;<br />        caddr_t ifru_data;<br />    }ifr_ifru;<br />};</p>
<p>#define ifr_addr     ifr_ifru.ifru_addr            // address<br />#define ifr_dstaddr   ifr_ifru.ifru_dstaddr         // otner end of p-to-p link<br />#define ifr_broadaddr ifr_ifru.ifru_broadaddr    // broadcast address<br />#define ifr_flags     ifr_ifru.ifru_flags        // flags<br />#define ifr_metric    ifr_ifru.ifru_metric      // metric<br />#define ifr_data      ifr_ifru.ifru_data        // for use by interface</p>
<p>再调用ioctl前我们必须先分撇一个缓冲区和一个ifconf结构，然后才初始化后者。如下图<br />展示了一个ifconf结构的初始化结构，其中缓冲区的大小为1024，ioctl的第三个参数指向<br />这样一个ifconf结构。<br />ifc_len<br />Ifc_buf<br />1024<br />---------------------&gt;缓存</p>
<p>假设内核返回2个ifreq结构，ioctl返回时通过同一个ifconf结构缓冲区填入了那2个ifreq结构，ifconf结构的ifc_len成员也被更新，以反映存放在缓冲区中的信息量<br />一般来讲ioctl在用户程序中的调用是：<br />ioctl(int fd,int command, (char*)argstruct)<br />ioctl调用与网络编程有关（本文只讨论这一点），文件描述符fd实际上是由socket()系统调用返回的。参数command的取值由/usr/include/linux/sockios.h所规定。这些command的由于功能的不同，可分为以下几个小类：<br />1.改变路由表 (例如 SIOCADDRT, SIOCDELRT), <br />2. 读/更新 ARP/RARP 缓存(如：SIOCDARP, SIOCSRARP), <br />3. 一般的与网络接口有关的(例如 SIOCGIFNAME, SIOCSIFADDR 等等) <br />在Gooodies 目录下有很多样例程序展示了如何使用ioctl。当你看这些程序时，注意参数argstruct是与参数command相关的。例如，与路由表相关的 ioctl使用rtentry这种结构，rtentry定义在/usr/include/linux/route.h（参见例子 adddefault.c）。与ARP有关的ioctl调用使用arpreq结构，arpreq定义在 /usr/include/linux/if_arp.h（参见例子arpread.c）<br />与网络接口有关的ioctl调用使用的command参数通常看起来像SIOCxIFyyyy的形式，这里x要 么是S（设定set，写write），要么是G（得到get，读read）。在getifinfo.c程序中就使用了这种形式的command参数来读 IP地址，硬件地址，广播地址和得到与网络接口有关的一些标志（flag）。在这些ioctl调用中，第三个参数是ifreq结构，它在 /usr/include/linux/if.h中定义。在某些情况下， ioctrl调用可能会使用到在sockios.h之外的新的定义，例如，WaveLAN无线网络卡会保存有关无线网络信号强度的信息，这对用户的程序可 能有用。但用户怎么得到这种信息呢？我们的第一个本能是在sockios.h中定义新的ioctl命令，例如SIOCGIFWVLNSS（它的英文缩写表 示WaveLAN的信号强度）。但不幸的是，这种命令不是对所有其他的网络接口（例如：loopback环回接口）有意义，而且不应当允许对于 WAVLAN卡以外的网络接口使用ioctl命令。那么，我们需要的是这样一种机制：它能够定义一种与网络接口相关的ioctl命令。幸运的是，在 Linux操作系统中已经为实现这个目的内建了一种挂钩（hook）机制。当你再次看sockios.h文件时，你将发现每一种设备已经预先定义了 SIOCDEVPRIVATE的ioctl命令。而它的实现将留给开发相应驱动程序的人去完成。<br />通常，一个用户程序使用ioctl (sockid,SIOCDEVPRIVATE,(char*)&amp;ifr)来调用与某种设备（指像WaveLAN那样的特殊设备）相关的 ioctl命令，这里ifr是struct ifreq ifr形式的变量。用户程序应当在ifr.ifr_name中填充与这个设备相关的名字，例如，假设WaveLAN使用的接口号为eth1。一般的，一个 用户程序还需要与内核互相交换ioctl的command参数和结果，这可以通过ifr.ifr_data这个变量来实现，例如，想得到WaveLAN中 表示信号强度的信息时，可以通过返回这个变量来实现。Linux的源代码已经包括了两种设备de4x5和ewrk3，它们定义并且实现了特定的ioctl 调用。这两个设备的源代码在de4x5.h,de4x5.c,ewrk3.h,ewrk3.c中（在 /usr/src/linux/drivers/net/目录中）。这两种设备都定义了它们特有的结构（struct ewrk3_ioctl 和 struct de4x5_ioctl）来方便用户程序和设备驱动之间交换信息。每次调用ioctl前，用户程序应当在相应的结构变量中设定合适的初值，并且将 ifr.ifr_data指向该值。<br />在我们进一步讨论ewrk3和de4x5的代码前，让我们仔细看看ioctl调用是如何一步步地实现的。所有的和接口相关的ioctl请求 (SIOCxIFyyyy 和 SIOCDEVPRIVATE)将会调用dev_ioctl()（在/usr/src/linux/net/core/dev.c中）。但这只是一个包装 器（wrapper），实际的动作将由dev_ifsioc()（也在dev.c中）来实现。差不多dev_ioctl()这个函数所做的所有工作只是检 查这个调用是否已经有了正当的权限（例如，改变路由表需要有root的权限）。而dev_ifsioc()这个函数首先要做的一些事情包括得到与 ifr.ifr_name相匹配的设备的结构（在/usr/include/linux/netdevice.h中定义）。但这是在实现特定的接口命令 （例如：SIOCGIFADDR）之后。这些特定的接口命令被放置到一个巨大的switch语句之中。其中SIOCDEVPRIVATE命令和其他的在 0x89F0到0x89FF之间的代码将出现在switch语句中的一个分支——default语句中。内核会检查表示设备的结构变量中，是否已经定义了 一个与设备相关的ioctl句柄（handler）。这里的句柄是一个函数指针，它在表示设备的结构变量中do_ioctl部分。如果已经设置了这个句 柄，那么内核将会执行它。<br />所以，如果要实现一个与设备相关的ioctl命令，所要做的只是编写一个与这个设备相关的ioctl句柄，并且将表示这 个设备的结构变量中do_ioctl部分指向这个句柄。对于ewrk3这个设备，它的句柄是ewrk3_ioctl()（在ewrk3.c里面）并且相应 的表示该设备的结构变量由ewrk3_init()来初始化。在ewrk3_ioctl()的代码中清晰的指出ifr.ifr_data是用作设备驱动程 序和用户程序之间交换信息的。注意，这部分的内存可以双向的交流信息。例如，在ewrk3的驱动程序代码中，if.ifr_data的头两个字节是用来表 示特殊的动作（例如，EWRK3_SET_PROM,EWRK3_CLR_PROM），而这个动作是符合使用者（驱动程序实现了多个与设备相关的、由 SIOCDEVPRIVATE调用的命令）的要求的。另外，ifr.ifr_data中第5个字节指向的缓冲区(buffer)被用来交换其他的信息 （如：当使用EWRK3_SET_HWADDR和EWRK3_GET_HWADDR时为硬件地址）<br />在你深入ewrk3_ioctl()时，请注意一般情况下一个用户进程不能直接访问内核所在的内存。为此，驱动开发者可以使用两个特殊的函数 memcpy_tofs()和memcpy_fromfs()。内核函数memcpy_tofs(arg1, arg2, arg3) 从地址arg2（用户空间）向地址arg1(内核空间)拷贝arg3个字节。类似的，memcpy_fromfs(arg1,arg2,arg3)从地址 arg2（用户空间）向地址arg1（内核空间）拷贝arg3个字节。在这些调用之前，verify_area()将会检查这个进程是否拥有合适的访问权 限。另外，注意使用printk()函数可以输出debug信息。这个函数与printf()函数类似，但不能处理浮点类型的数。内核代码不能够使用 printf()函数。printk()函数产生的结果将记录在/usr/adm/messages里。如果想知道更多的关于这些函数的或者与它们相关的 信息，可以参考《Linux Kernel Hacker’s Guide》（在Linux文档网站的首页） 这本书中Supporting Functions部分。</p>
<p>使用ioctl与内核交换数据</p>
<p>1. 前言 </p>
<p>使用ioctl系统调用是用户空间向内核交换数据的常用方法之一，从ioctl这个名称上看，本意是针对I/O设备进行的控制操作，但实际并不限制是真正的I/O设备，可以是任何一个内核设备即可。</p>
<p>2. 基本过程</p>
<p>在内核空间中ioctl是很多内核操作结构的一个成员函数，如文件操作结构struct file_operations(include/linux/fs.h)、协议操作结构struct proto_ops(include/linux/net.h)等、tty操作结构struct tty_driver(include/linux/tty_driver.h)等，而这些操作结构分别对应各种内核设备，只要在用户空间打开这些设备， 如I/O设备可用open(2)打开，网络协议可用socket(2)打开等，获取一个文件描述符后，就可以在这个描述符上调用ioctl(2)来向内核 交换数据。</p>
<p>3. ioctl(2)</p>
<p>ioctl(2)函数的基本使用格式为：<br />int ioctl(int fd, int cmd, void *data)<br />第一个参数是文件描述符；cmd是操作命令，一般分为GET、SET以及其他类型命令，GET是用户空间进程从内核读数据，SET是用户空间进程向内核写数据，cmd虽然是一个整数，但是有一定的参数格式的，下面再详细说明；第三个参数是数据起始位置指针，<br />cmd命令参数是个32位整数，分为四部分：<br />dir(2b) size(14b) type(8b) nr(8b)<br />详细定义cmd要包括这4个部分时可使用宏_IOC(dir,type,nr,size)来定义，而最简单情况下使用_IO(type, nr)来定义就可以了，这些宏都在include/asm/ioctl.h中定义<br />本文cmd定义为：<br />#define NEWCHAR_IOC_MAGIC   'M'<br />#define NEWCHAR_SET    _IO(NEWCHAR_IOC_MAGIC, 0)<br />#define NEWCHAR_GET    _IO(NEWCHAR_IOC_MAGIC, 1)<br />#define NEWCHAR_IOC_MAXNR   1</p>
<p>要定义自己的ioctl操作，可以有两个方式，一种是在现有的内核代码中直接添加相关代码进行支持，比如想通过socket描述符进行 ioctl操作，可在net/ipv4/af_inet.c中的inet_ioctl()函数中添加自己定义的命令和相关的处理函数，重新编译内核即可， 不过这种方法一般不推荐；第二种方法是定义自己的内核设备，通过设备的ioctl()来操作，可以编成模块，这样不影响原有的内核，这是最通常的做法。</p>
<p>4. 内核设备</p>
<p>为进行ioctl操作最通常是使用字符设备来进行，当然定义其他类型的设备也可以。在用户空间，可使用mknod命令建立一个字符类型设备文件，假设该设备的主设备号为123，次设备号为0：<br />mknode /dev/newchar c 123 0<br />如果是编程的话，可以用mknode(2)函数来建立设备文件。</p>
<p>建立设备文件后再将该设备的内核模块文件插入内核，就可以使用open(2)打开/dev/newchar文件，然后调用ioctl(2)来传递数据，最后用close(2)关闭设备。而如果内核中还没有插入该设备的模块，open(2)时就会失败。</p>
<p>由于内核内存空间和用户内存空间不同，要将内核数据拷贝到用户空间，要使用专用拷贝函数copy_to_user()；要将用户空间数据拷贝到内核，要使用copy_from_user()。<br />要最简单实现以上功能，内核模块只需要实现设备的open, ioctl和release三个函数即可，<br />下面介绍程序片断：<br />static int newchar_ioctl(struct inode *inode, struct file *filep, <br />   unsigned int cmd, unsigned long arg);<br />static int newchar_open(struct inode *inode, struct file *filep);<br />static int newchar_release(struct inode *inode, struct file *filep);<br />// 定义文件操作结构，结构中其他元素为空<br />struct file_operations newchar_fops = <br />{<br />owner: THIS_MODULE,<br />ioctl: newchar_ioctl,<br />open: newchar_open,<br />release: newchar_release,<br />};<br />// 定义要传输的数据块结构<br />struct newchar{<br />int a;<br />int b;<br />};<br />#define MAJOR_DEV_NUM 123<br />#define DEVICE_NAME "newchar"</p>
<p>打开设备，非常简单，就是增加模块计数器，防止在打开设备的情况下删除模块,<br />当然想搞得复杂的话可进行各种限制检查，如只允许指定的用户打开等：<br />static int newchar_open(struct inode *inode, struct file *filep)<br />{<br />MOD_INC_USE_COUNT;<br />return 0;<br />}</p>
<p>关闭设备，也很简单，减模块计数器：<br />static int newchar_release(struct inode *inode, struct file *filep)<br />{<br />MOD_DEC_USE_COUNT;<br />return 0;<br />}</p>
<p>进行ioctl调用的基本处理函数<br />static int newchar_ioctl(struct inode *inode, struct file *filep, <br />      unsigned int cmd, unsigned long arg)<br />{<br />int ret;<br />// 首先检查cmd是否合法<br />if (_IOC_TYPE(cmd) != NEWCHAR_IOC_MAGIC) return -EINVAL;<br />if (_IOC_NR(cmd) &gt; NEWCHAR_IOC_MAXNR) return -EINVAL;<br />// 错误情况下的缺省返回值<br />ret = EINVAL;<br />switch(cmd)<br />{<br />case KNEWCHAR_SET:<br />// 设置操作，将数据从用户空间拷贝到内核空间<br />{<br />   struct newchar nc;<br />   if(copy_from_user(&amp;nc, (const char*)arg, sizeof(nc)) != 0)<br />    return -EFAULT;<br />   ret = do_set_newchar(&amp;nc);<br />}<br />break;<br />case KNEWCHAR_GET:<br />// GET操作通常会在数据缓冲区中先传递部分初始值作为数据查找条件，获取全部<br />// 数据后重新写回缓冲区<br />// 当然也可以根据具体情况什么也不传入直接向内核获取数据<br />{<br />   struct newchar nc;<br />   if(copy_from_user(&amp;nc, (const char*)arg, sizeof(nc)) != 0)<br />    return -EFAULT;<br />   ret = do_get_newchar(&amp;nc);<br />   if(ret == 0){<br />    if(copy_to_user((unsigned char *)arg, &amp;nc, sizeof(nc))!=0)<br />     return -EFAULT;<br />   }<br />}<br />break;<br />}<br />return ret;<br />}<br />模块初始化函数，登记字符设备<br />static int __init _init(void)<br />{<br />int result;<br />// 登记该字符设备，这是2.4以前的基本方法，到2.6后有了些变化，<br />// 是使用MKDEV和cdev_init()来进行，本文还是按老方法<br />result = register_chrdev(MAJOR_DEV_NUM, DEVICE_NAME, &amp;newchar_fops);<br />if (result &lt; 0) {<br />printk(KERN_WARNING __FUNCTION__ ": failed register character device for /dev/newchar\n");<br />return result;<br />}<br />return 0;<br />}</p>
<p>模块退出函数，登出字符设备<br />static void __exit _cleanup(void)<br />{<br />int result;<br />result = unregister_chrdev(MAJOR_DEV_NUM, DEVICE_NAME);<br />if (result &lt; 0)<br />printk(__FUNCTION__ ": failed unregister character device for /dev/newchar\n");<br />return;<br />} <br />module_init(_init);<br />module_exit(_cleanup);</p>
<p>5. 结论</p>
<p>用ioctl()在用户空间和内核空间传递数据是最常用方法之一，比较简单方便，而且可以在同一个ioctl中对不同的命令传送不同的数据结构，本文只是为描述方便而在不同命令中使用了相同的数据结构。</p>
<p>from:http://hi.baidu.com/liaolihome/blog/item/e72e012a85412d9e033bf61b.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 01:00:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/cmd/" title="cmd">cmd</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ioctl用法详解 (网络)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKKVZz.html" rel="bookmark">《Ansible权威指南》一2&period;4　Ansible系列命令用法详解与使用场景介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 Ansible系列命令用法详解与使用场景介绍 如何获取Ansible的系列命令呢?在终端键入ansible后连续按两次Tab键,会补全所有以ansible字母开头的命令,这些命令均是Ansible系列命令.本节我们来逐一介绍Ansible的系列命令使用. ansible ansible-galaxy ansible-pull ansible-doc ansible-playbook ansible-vault ansible-console 2.4.1 ansible 命令ansible			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKkyZz.html" rel="bookmark">php5&period;3后静态绑定用法详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php5.3后静态绑定用法.分享给大家供大家参考,具体如下: 手册原文: 自 PHP 5.3.0 起,PHP 增加了一个叫做后期静态绑定的功能,用于在继承范围内引用静态调用的类. 准确说,后期静态绑定工作原理是存储了在上一个&quot;非转发调用&quot;(non-forwarding call)的类名.当进行静态方法调用时,该类名即为明确指定的那个(通常在 :: 运算符左侧部分):当进行非静态方法调用时,即为该对象所属的类.所谓的&quot;转发调用&quot;(forwarding c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N2lrp.html" rel="bookmark">php图像处理函数imagecopyresampled用法详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php图像处理函数imagecopyresampled用法.分享给大家供大家参考,具体如下: 语法 复制代码 代码如下: bool imagecopyresampled ( resource $dst_image , resource $src_image , int $dst_x , int $dst_y , int $src_x , int $src_y , int $dst_w , int $dst_h , int $src_w , int $src_h ) 参数 dst_i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmmJYp.html" rel="bookmark">Smarty变量用法详解&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Smarty变量用法.分享给大家供大家参考,具体如下: 1. 从PHP分配的变量 调用从PHP分配的变量需在前加&quot;$&quot;符号.(译注:同php一样) 调用模板内的assign函数分配的变量也是这样.(译注:也是用$加变量名来调用) 示例: index.php: $smarty = new Smarty; $smarty-&gt;assign('firstname', 'Doug'); $smarty-&gt;assign('lastLoginDate', 'January1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkYAKM.html" rel="bookmark">jar命令的用法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文详细讲述了JAR命令的用法,对于大家学习和总结jar命令的使用有一定的帮助作用.具体如下: JAR包是Java中所特有一种压缩文档,其实大家就可以把它理解为.zip包.当然也是有区别的,JAR包中有一个META-INF\MANIFEST.MF文件,当你找成JAR包时,它会自动生成. JAR包是由JDK安装目录\bin\jar.exe命令生成的,当我们安装好JDK,设置好path路径,就可以正常使用jar.exe命令,它会用lib\tool.jar工具包中的类.这些细节就不用管它了. 让我们看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Nv04b.html" rel="bookmark">Android中使用HTTP服务的用法详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Android中,除了使用Java.NET包下的API访问HTTP服务之外,我们还可以换一种途径去完成工作.Android SDK附带了Apache的HttpClient API.Apache HttpClient是一个完善的HTTP客户端,它提供了对HTTP协议的全面支持,可以使用HTTP GET和POST进行访问.下面我们就结合实例,介绍一下HttpClient的使用方法. 我们新建一个http项目,项目结构如图: 在这个项目中,我们不需要任何的Activity,所有的操作都在单元测试类H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LpdX8Np.html" rel="bookmark">php9个超全局变量的用法详解（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天来讲一下$_GET()与$_POST(). 其实很容易理解,根据表面意思就可以看得出来,是获得post与get表单的数据,其实也正是如此,来点专业的话来讲, $_GET 变量是一个数组,内容是由 HTTP GET 方法发送的变量名称和值. $_GET 变量用于收集来自 method=&quot;get&quot; 的表单中的值.从带有 GET 方法的表单发送的信息,对任何人都是可见的(会显示在浏览器的地址栏),并且对发送的信息量也有限制(最多 100 个字符).好,看个例子,上简单登录界面的代码: 登			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbEGOPp.html" rel="bookmark">php9个超全局变量的用法详解（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP 中的许多预定义变量都是&quot;超全局的&quot;,这意味着它们在一个脚本的全部作用域中都可用.在函数或方法中无需执行 global $variable; 就可以访问它们. 这些超全局变量是: $GLOBALS $_SERVER $_GET $_POST $_FILES $_COOKIE $_SESSION $_REQUEST $_ENV 1.先看一下$GLOBALS,它是包含了全部变量的全局组合数组,什么意思呢,看一个c语言程序 int main() { int a = 3; void t(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bor6Ez.html" rel="bookmark">C&plus;&plus; Iostreams用法详解（四）缓冲区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面说到过每一个iostream对象都有一个缓冲区,我们称之为流缓冲区,那个这个所谓的流缓冲区是怎 么存在的呢?iostreams中将该流缓冲区抽象为一个类,即streambuf类. 每个iostream的类都会包含 一个指向streambuf对象的指针,这也就意味着我们可以直接的去访问到这个指针,并向该streambuf对象发送 消息等(但是一般情况下我们并不需要这样做). 既然说我们可以得到这个指针,那isotreams类当然 会提供访问的接口了,这就是const成员函数rdbuf(),它			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE8e9z.html" rel="bookmark" class="title">电子商务是传统企业发展的唯一选择！</a>
					<div>
						电子商务是传统企业发展的唯一选择! 两天没来了,最近在想一个问题,很严重,看看你重视了没有! 今年来,京东凡客等先后拿到大额融资,麦考林于上个月在美国纳斯达克成功上市,成为中国首家B2C上市公司,当当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo0mXM.html" rel="bookmark" class="title">用ASP建立一个简单的聊天室</a>
					<div>
						聊天室|聊天室     经过一个阶段的asp学习,下面我们结合所学过的内容建立一个最简单的聊天室,虽然很简单,但是大家可以通过他来掌握一个聊天室建立的基本过程,并且可以不断的完善其功能. 下面介绍其主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB5Woz.html" rel="bookmark" class="title">个人网站发展初期如何节省资金</a>
					<div>
						个人网站 谈谈个人网站发展初期如何节省资金(200元起家)发展状大的问题(原创) 很多个人网站主,包括我,都是一边上班,一边做站,并想着某一天网站的收入能超过工资收入了,就不用上班了,做一个专职的网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOj6qp.html" rel="bookmark" class="title">Photoshop婚纱相片教程&colon;黄褐色调的温馨情侣照</a>
					<div>
						本教程调色用到了通道替换法.直接用绿色通道替换蓝色通道,做出青红色图片,然后针对这两种颜色调色,转为自己需要的黄褐色即可.原图 最终效果 [1] [2] [3] [4] [5] [6] [7] [8] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN6ByM.html" rel="bookmark" class="title">Windows7系统环境安装配置PHP开发环境</a>
					<div>
						一.Apache安装版本解释:openssl是表示带有openssl模块,利用openssl就可以给Apache配置SSL安全链接的,也就是使用https://方式进行访问. nossl则表示不带Op ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPdJ1p.html" rel="bookmark" class="title">动态加载服务器控件（整理）</a>
					<div>
						代码示例1: dlist = New System.Web.UI.WebControls.DropDownList()dlist.Items.Clear()dlist.ID = &quot;d&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRxa3z.html" rel="bookmark" class="title">是适应不同人群的完美网页</a>
					<div>
						发现很多站点用的都是pt和px字体CSS定义.滚动根本就无效--回看自己的个站,字体滚动是支持了. 标准: 引用代码 以下为引用的内容: body { text-align:center; heigh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOxqkb.html" rel="bookmark" class="title">网站监测对于SEO策略是至关重要</a>
					<div>
						一般来说,当网站从上线,通常会经历四种时期,即沙盒期,缓冲期,上升期,以及巅峰期.然而,对于这四种时期,在我们在进行SEO方案的策略时,以及后期的方案执行时,所得到的效果如何?这期的主题,东莞SEO阿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYl7Qb.html" rel="bookmark" class="title">供水设备网教您如何让百度4小时之内收录</a>
					<div>
						最近刚刚换了工作,在一家供水设备公司上班,老总要我快速的做一个供水设备行业网站,并快速的上线,让百度尽快收录,因为供水设备行业站之前还是一个蓝海,但是最近一段时间,突然冒出了两个抢占了先机,老板急的要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0586p.html" rel="bookmark" class="title">在 C&num; 中处理结构内的数组</a>
					<div>
						数组 在 C/C++ 代码中,大量掺杂着包括普通类型和数组的结构,如定义 PE 文件头结构的 IMAGE_OPTIONAL_HEADER 结构定义如下: 以下内容为程序代码: typedef stru ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwNPYb.html" rel="bookmark" class="title">jQuery 追加元素的方法如append、prepend、before</a>
					<div>
						 jQuery - 追加元素的方法有很多如append.prepend.before等等,下面为大家详细介绍下 1.jQuery append() 方法    jQuery append() 方法在被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGXGqb.html" rel="bookmark" class="title">windows7每次开机总是提示&OpenCurlyDoubleQuote;资源管理器已停止工作&rdquo;</a>
					<div>
						  我们在使用Win7系统的时候会出现这样的情况;每次开机都提示&quot;资源管理器已停止工作这是因为WinRAR设置不当从而就会出现的问题,Win7的系统资源管理器的执行文件是&quot;expl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmvVdz.html" rel="bookmark" class="title">U盘变身路由器的小秘密</a>
					<div>
						  准备工具:一个小小的U盘,DD-WRT路由器固件,为整机追加一张网卡或是一个集线器也是必要的. 关于DD-WRT简介 我们平常使用的每一台路由器设备,都有一个自己的操作系统OS,用于对路由设备进行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E8yxM.html" rel="bookmark" class="title">苹果电脑如何装Win 7&quest;</a>
					<div>
						  一.准备工作 1.软件需求 ⑴ WIN7安装版ISO镜像 (建议使用正版,如果没可以下载其他版本,地址问百度) ⑵ Windows 7 USB DVD Download Tool(用于制作WIN7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EO4XM.html" rel="bookmark" class="title">分析师预测甲骨文数据库12&period;2的市场策略将打击用户</a>
					<div>
						Oracle已经确认,其12c数据库下一次的重大升级在一段时间内只针对云平台,希望此举能够吸引仍旧使用内部部署模式的客户. Oracle负责数据库产品管理的副总裁Penny Avril在星期二表示,O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxl8Wb.html" rel="bookmark" class="title">网站权重提升的几个技巧</a>
					<div>
						一.网站内容和内链构造 网站内容是一个网站的血肉,也是让搜索引擎爬虫喜欢的&quot;食物&quot;,网站有了丰富的内容和新鲜的血液,生命力才会更强.不管做什么类型的网站,内容始终是一个难题,但是也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7POkz.html" rel="bookmark" class="title">关于Clist问题</a>
					<div>
						问题描述 程序里使用CList存储数据的,在几个cpp里创建了多个CList对象,并作为全局变量使用的,导致了程序运行很慢,请问大家有什么方法可以解决呢? 解决方案 解决方案二:程序是可以运行的,当处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32qO7z.html" rel="bookmark" class="title">c&plus;&plus;-比较两个相等的函数里，当给两个不相等参数时，系统为什么会自动返回x的值呢？？</a>
					<div>
						问题描述 比较两个相等的函数里,当给两个不相等参数时,系统为什么会自动返回x的值呢?? int fun(int aint b){ if(a == b) { return a; }} void main ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7glWp.html" rel="bookmark" class="title">java方法块-java当中trim方法是干什么用的</a>
					<div>
						问题描述 java当中trim方法是干什么用的 java当中trim方法是干什么用的 好像记得是数组对象才可以调用此方法是吧 解决方案 你说的是String类中的方法trim,这个trim用来去除字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDLXBz.html" rel="bookmark" class="title">Lua 脚本 C&plus;&plus; 封装库 LuaWrapper</a>
					<div>
						为什么要用Lua作脚本? 使用Lua作脚本,主要是因为它小巧玲珑(体积小,运行快),而且它的语法又比较简单明了.不过,使用LuaAPI将Lua引擎集成到程序中,确实有一些不方便--用落木随风网友的话来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLv6VM.html" rel="bookmark" class="title">编程-如何让任务管理器关不掉我的程序&quest;</a>
					<div>
						问题描述 如何让任务管理器关不掉我的程序? 写一个程序,然后运行,让任务管理器关不掉,怎样才能实现?谢谢. 解决方案 Hook应该搞得定 windows的 解决方案二: 今天加壳脱壳完毕,想删掉那些用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoGOjM.html" rel="bookmark" class="title">Deepmind 开发可微分神经计算机： 我们离会推理的机器人还有多远</a>
					<div>
						还记得击败世界围棋大师的阿尔法狗 AlphaGo 吗? 它来自谷歌 DeepMind 团队,现在这个人工智能实验室又推出了一项重磅研究--可微分神经计算机的神经网络模型(Differentiable  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2q71M.html" rel="bookmark" class="title">ASP&period;NET MVC小结之基础篇（二）&lowbar;实用技巧</a>
					<div>
						整理除了这个笔记,共享一下子,基本MVC的所有东西都介绍了,但是都是很基础的东西.本来打算一篇发表完的,但是发现东西有点多,所以分成了两篇文章,这是最后一篇了! 1.ASP.NET MVC请求过程 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmxqRp.html" rel="bookmark" class="title">浅析c&plus;&plus;中new和delete的用法&lowbar;C 语言</a>
					<div>
						new和delete运算符用于动态分配和撤销内存的运算符 new用法: 1.开辟单变量地址空间1)new int;  //开辟一个存放数组的存储空间,返回一个指向该存储空间的地址.int *a = n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1LnKb.html" rel="bookmark" class="title">js实现滚动条滚动到某个位置便自动定位某个tr&lowbar;javascript技巧</a>
					<div>
						要实现带滚动条的table,定位到某个tr,其实是很简单的,只有几行js代码就可以完成,具体内容如下 js代码 &lt;strong&gt;&lt;script type=&quot;text/jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNg6Zp.html" rel="bookmark" class="title">利用Redis缓存提高斐波拉契数列程序的性能例子</a>
					<div>
						去某家公司面试,PHP岗位,先做笔试,再两轮面试,最后hr面,拿了offer.   笔试题都不难,做完随手拍了一张,然后回去把这道求斐波那契数列的题在电脑上运行了一遍,写的当然是对的,但是当你要求第N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLA8VM.html" rel="bookmark" class="title">《SAP入门经典（第5版）》&mdash;&mdash;2&period;4　SAP业务流程样例</a>
					<div>
						2.4 SAP业务流程样例 为了让您了解为什么公司要花费这么多时间和金钱,投入这么多人力引进SAP,本节介绍几种常用的业务流程.在每个情景中,您将看到公司的最终用户如何在日常工作中使用SAP应用运行公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmO2xz.html" rel="bookmark" class="title">vb&period;net combox的text和value如何绑</a>
					<div>
						问题描述 vb.netcombox的text和value如何绑:例如:添加一个记录Name,它的值为&quot;good&quot;cmbbo.Items.Insert(nIndex,Name)如何把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdm3O3z.html" rel="bookmark" class="title">link如何把计算结果保存为二进制文件，并恢复数据？</a>
					<div>
						问题描述 link如何把计算结果保存为二进制文件,并恢复数据? link如何把计算结果保存为二进制文件,并恢复数据?link如何把计算结果保存为二进制文件,并恢复数据? 解决方案 直接用File.Wr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6y1Ap.html" rel="bookmark" class="title">Request和Session的区别</a>
					<div>
						request字面意思理解就是一个请求,比如提交一个表单就是一个请求,打开一个超链接也是一个请求,当请求结束这个request也就消亡了 session字面意思是一个会话,会话的概念就不多说了, 当用 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
